package compbio.cassandra.readers;

import java.util.Calendar;
import java.util.List;
import java.util.ArrayList;

import com.datastax.driver.core.Row;
import com.datastax.driver.core.Session;
import com.datastax.driver.core.ResultSet;

import compbio.engine.Pair;

public class CassandraReaderExecutionTime {
	private Session session;

	public static String CASSANDRA_HOSTNAME = "localhost";
	public static boolean READ_WEB_JPRED = false;
	public static boolean READ_LOCALFILE_JPRED = false;

	public void setSession(Session s) {
		assert s != null;
		session = s;
	}

	public boolean JobisNotInsterted(String jobid) {
		ResultSet results1 = session.execute("SELECT * FROM ProteinLog WHERE JobID = '" + jobid + "';");
		if (results1.isExhausted()) {
			return true;
		}
		return false;
	}

	public boolean JobisNotArchived(String jobid) {
		ResultSet results1 = session.execute("SELECT * FROM JpredArchive WHERE JobID = '" + jobid + "';");
		if (results1.isExhausted()) {
			return true;
		}
		return false;
	}

	/*
	 * getting data from the db
	 */
	public List<Pair<String, String>> ReadProteinDataTable() {
		final long startTime = System.currentTimeMillis();
		String com = "SELECT DataBegin,DataEnd FROM ProteinKeyspace.ProteinLog;";
		System.out.println("Command: " + com);
		ResultSet results = session.execute(com);
		final long queryTime = System.currentTimeMillis();
		List<Row> rows = results.all();
		System.out.println("Query time is " + (queryTime - startTime) + " msec");

		List<Pair<String, String>> res = new ArrayList<Pair<String, String>>();
		int c = 0;
		for (Row r : rows) {
			Pair<String, String> pair = new Pair<String, String>(r.getString("DataBegin"), r.getString("DataEnd"));
			res.add(pair);
			++c;
		}
		final long endTime = System.currentTimeMillis();
		System.out.println(c + " rows analysed, execution time is " + (endTime - startTime) + " msec");
		return res;
	}

	/*
	 * getting earlest date of jobs from the db
	 */
	public long getEarliestDateInDB() {
		final long startTime = System.currentTimeMillis();
		String com = "SELECT jobtime FROM ProteinKeyspace.ProteinData;";
		System.out.println("Command: " + com);
		ResultSet results = session.execute(com);
		final long queryTime = System.currentTimeMillis();
		System.out.println("Query time is " + (queryTime - startTime) + " msec");

		Calendar cal = Calendar.getInstance();
		long res = cal.getTimeInMillis();
		int c = 0;
		while (!results.isExhausted()) {
			Row r = results.one();
			long d1 = r.getLong("jobtime");
			if (res > d1) {
				res = d1;
			}
			++c;
		}
		final long endTime = System.currentTimeMillis();
		System.out.println(c + " rows analysed, execution time is " + (endTime - startTime) + " msec");
		return res;
	}

}
